searchData={"content_type":"text/plain","items":[{"doc":"Generic Zipper Implementation. Zippers let you traverse immutable data structures with ease and flexibility.","ref":"zipper.html","title":"zipper","type":"module"},{"doc":"Adds a node as the rightmost child of the current one.","ref":"zipper.html#append_child/2","title":"zipper.append_child/2","type":"function"},{"doc":"Returns the list of children zippers.","ref":"zipper.html#children/1","title":"zipper.children/1","type":"function"},{"doc":"Returns the zipper in the first child, if any.","ref":"zipper.html#down/1","title":"zipper.down/1","type":"function"},{"doc":"Edits the current node by applying the given function. The parameters of said function will be [Node | Args].","ref":"zipper.html#edit/3","title":"zipper.edit/3","type":"function"},{"doc":"Returns a list of all the nodes in the zipper that match a predicate.","ref":"zipper.html#filter/2","title":"zipper.filter/2","type":"function"},{"doc":"Returns the root of the tree, where the value of each node (after the current location of Zipper) is replaced with the result from applying Fun to the node as the first argument and Args as additional arguments.","ref":"zipper.html#fmap/3","title":"zipper.fmap/3","type":"function"},{"doc":"Applies Fun recursively on the zipper. The arguments of Fun will be (Node, Acc) where Acc is the result of the previous call or the initial value provided.","ref":"zipper.html#fold/3","title":"zipper.fold/3","type":"function"},{"doc":"Adds a node as the leftmost child of the current one.","ref":"zipper.html#insert_child/2","title":"zipper.insert_child/2","type":"function"},{"doc":"Inserts a node to the left of the current one.","ref":"zipper.html#insert_left/2","title":"zipper.insert_left/2","type":"function"},{"doc":"Inserts a node to the right of the current one.","ref":"zipper.html#insert_right/2","title":"zipper.insert_right/2","type":"function"},{"doc":"Is this node a branch?","ref":"zipper.html#is_branch/1","title":"zipper.is_branch/1","type":"function"},{"doc":"Is it the end of the zipper traversal.","ref":"zipper.html#is_end/1","title":"zipper.is_end/1","type":"function"},{"doc":"Returns the zipper on the left, if any.","ref":"zipper.html#left/1","title":"zipper.left/1","type":"function"},{"doc":"Returns the leftmost zipper in the current zipper.","ref":"zipper.html#leftmost/1","title":"zipper.leftmost/1","type":"function"},{"doc":"Applies a function to all nodes of the zipper. Returns a list with the results.","ref":"zipper.html#map/2","title":"zipper.map/2","type":"function"},{"doc":"Builds a new zipper with nodes of type T.","ref":"zipper.html#new/4","title":"zipper.new/4","type":"function"},{"doc":"Returns the next zipper.","ref":"zipper.html#next/1","title":"zipper.next/1","type":"function"},{"doc":"Returns the value of the current node in the zipper.","ref":"zipper.html#node/1","title":"zipper.node/1","type":"function"},{"doc":"Returns the previous zipper.","ref":"zipper.html#prev/1","title":"zipper.prev/1","type":"function"},{"doc":"Removes current node from zipper. Moves down, if possible. If not, it moves to the rightmost node.","ref":"zipper.html#remove/1","title":"zipper.remove/1","type":"function"},{"doc":"Replaces the current node.","ref":"zipper.html#replace/2","title":"zipper.replace/2","type":"function"},{"doc":"Returns the zipper on the right, if any.","ref":"zipper.html#right/1","title":"zipper.right/1","type":"function"},{"doc":"Returns the rightmost zipper in the current zipper.","ref":"zipper.html#rightmost/1","title":"zipper.rightmost/1","type":"function"},{"doc":"Returns the node on the root of the zipper.","ref":"zipper.html#root/1","title":"zipper.root/1","type":"function"},{"doc":"Returns the size of the zipper.","ref":"zipper.html#size/1","title":"zipper.size/1","type":"function"},{"doc":"Traverses the zipper following the given list of operations. If, at some point, an operation is invalid, it will crash.","ref":"zipper.html#traverse/2","title":"zipper.traverse/2","type":"function"},{"doc":"Returns the zipper in the parent node, if possible.","ref":"zipper.html#up/1","title":"zipper.up/1","type":"function"},{"doc":null,"ref":"zipper.html#t:children_fun/1","title":"zipper.children_fun/1","type":"type"},{"doc":null,"ref":"zipper.html#t:info/1","title":"zipper.info/1","type":"type"},{"doc":null,"ref":"zipper.html#t:is_branch_fun/1","title":"zipper.is_branch_fun/1","type":"type"},{"doc":null,"ref":"zipper.html#t:make_node_fun/1","title":"zipper.make_node_fun/1","type":"type"},{"doc":null,"ref":"zipper.html#t:operation/0","title":"zipper.operation/0","type":"type"},{"doc":null,"ref":"zipper.html#t:zipper/1","title":"zipper.zipper/1","type":"opaque"},{"doc":null,"ref":"zipper_default.html","title":"zipper_default","type":"module"},{"doc":"Generates a zipper for binary trees.","ref":"zipper_default.html#bin_tree/1","title":"zipper_default.bin_tree/1","type":"function"},{"doc":"Generates a zipper for lists.","ref":"zipper_default.html#list/1","title":"zipper_default.list/1","type":"function"},{"doc":"Generates a zipper for maps.","ref":"zipper_default.html#map_tree/2","title":"zipper_default.map_tree/2","type":"function"},{"doc":null,"ref":"zipper_default.html#t:bin_tree_node/1","title":"zipper_default.bin_tree_node/1","type":"type"},{"doc":"# Zipper [![GitHub Actions CI](https://github.com/inaka/zipper/workflows/build/badge.svg)](https://github.com/inaka/zipper)\n\nGeneric zipper implementation in Erlang.","ref":"readme.html","title":"Zipper","type":"extras"},{"doc":"Zippers let you traverse immutable data structures with ease and flexibility.\n\n#","ref":"readme.html#zippers-what-are-they-good-for","title":"Zippers: what are they good for? - Zipper","type":"extras"},{"doc":"If you find any **bugs** or have a **problem** while using this library, please\n[open an issue](https://github.com/inaka/zipper/issues/new) in this repo (or a pull request :)).\n\nAnd you can check all of our open-source projects at [inaka.github.io](https://inaka.github.io)","ref":"readme.html#contact-us","title":"Contact Us - Zipper","type":"extras"},{"doc":"For a map tree structure like the following:\n\n```erlang\nRoot = #{type => planet,\n         attrs => #{name => \"Earth\"},\n         children => [\n           #{type => continent,\n             attrs => #{name => \"America\"},\n             children => [\n               #{type => country,\n                 attrs => #{name => \"Argentina\"},\n                 children => []},\n               #{type => country,\n                 attrs => #{name => \"Brasil\"},\n                 children => []}\n             ]\n            },\n           #{type => continent,\n             attrs => #{name => \"Europe\"},\n             children => [\n               #{type => country,\n                 attrs => #{name => \"Sweden\"},\n                 children => []},\n               #{type => country,\n                 attrs => #{name => \"England\"},\n                 children => []}\n             ]\n            }\n         ]\n        },\n```\n\nYou can build a zipper by providing three simple functions:\n\n- `IsBranchFun`: takes a node and returns `true` if it is a branch node or\n  `false` otherwise.\n- `ChildrenFun`: takes a node and returns a list of its children.\n- `MakeNodeFun`: takes a node and a list of children and returns a new node\n  containing the supplied list as children.\n\nThis is an example of how you would define a zipper and then use it to traverse\nthe map tree structure above:\n\n```erlang\n%% Create the zipper\nIsBranchFun = fun\n                  (#{children := [_ | _]}) -> true;\n                  (_) -> false\n              end,\nChildrenFun = fun(Node) -> maps:get(children, Node) end,\nMakeNodeFun = fun(Node, Children) -> Node#{children => Children} end,\nZipper = zipper:new(fun is_map/1, ChildrenFun, MakeNodefun, Root),\n\n%% Traverse the zipper with next\nZipper1 = zipper:next(Zipper),\nZipper2 = zipper:next(Zipper),\n\n%% Get the current zipper node\nArgentina = zipper:node(Zipper2).\nio:format(\"~p\", [Argentina]),\n%%= #{type => country,\n%%=   attrs => #{name => \"Argentina\"},\n%%=   children => []}\n\n%% Go up and get the node\nZipper3 = zipper:up(Zipper2).\nAmerica = zipper:node(Zipper2).\nio:format(\"~p\", [America]),\n%%= #{type => country,\n%%=   attrs => #{name => \"America\"},\n%%=   children => [#{...}, #{...}]}\n```","ref":"readme.html#usage","title":"Usage - Zipper","type":"extras"},{"doc":"Circular dependency in test environment ([Katana Test](https://github.com/inaka/katana-test) ->\n[Elvis Core](https://github.com/inaka/elvis_core) -> [Zipper](https://github.com/inaka/zipper)) is\nfixed by including Zipper as a dep in the test profile in `rebar.config`\n\n```erlang\n...\n{profiles, [\n  {test, [\n    {deps, [\n      %% The tag will be replaced by the rebar.config.script\n      {zipper,      {git, \"https://github.com/inaka/zipper.git\", {tag, \"irrelevant\"}}},\n      ...\n    ]}\n  ]}\n]}.\n...\n```\n\nbut then, we still replace the tag with the current branch. This is done in `rebar.config.script`.\nTherefore, it's really important to have the branch updated and pushed to github before running the\ntests with `rebar3 ct`.","ref":"readme.html#tests","title":"Tests - Zipper","type":"extras"},{"doc":"- [The Zipper, GERARD HUET](https://www.st.cs.uni-saarland.de/edu/seminare/2005/advanced-fp/docs/huet-zipper.pdf)\n- [clojure.zip](https://clojure.github.io/clojure/clojure.zip-api.html#clojure.zip/zipper)","ref":"readme.html#references","title":"References - Zipper","type":"extras"},{"doc":"# Apache License\n\n                           Version 2.0, January 2004\n                        https://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS\n\n   APPENDIX: How to apply the Apache License to your work.\n\n      To apply the Apache License to your work, attach the following\n      boilerplate notice, with the fields enclosed by brackets \"{}\"\n      replaced with your own identifying information. (Don't include\n      the brackets!)  The text should be enclosed in the appropriate\n      comment syntax for the file format. We also recommend that a\n      file or class name and description of purpose be included on the\n      same \"printed page\" as the copyright notice for easier\n      identification within third-party archives.\n\n   Copyright 2015 Erlang Solutions Ltd.\n\n   Licensed under the Apache License, Version 2.0 (the \"License\");\n   you may not use this file except in compliance with the License.\n   You may obtain a copy of the License at\n\n       https://www.apache.org/licenses/LICENSE-2.0\n\n   Unless required by applicable law or agreed to in writing, software\n   distributed under the License is distributed on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   See the License for the specific language governing permissions and\n   limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"}]}